# Include some dependancies
#
include 		${BACKPATH}core/make/options.mk		# Set your platform choices here
include 		${BACKPATH}core/make/strings.mk		# How the makefiles display what they are doing
include 		${BACKPATH}core/make/platforms.mk	# Platform defines

# Compiling, linking/lib (archive) creation
#
ifdef BINNAME
all : CompMsg ${OBJECTS}
	${DISN} ${MSG}${MSG_LINK}
	${LINK} ${BINNAME} ${OBJECTS} ${LIBRARIES}
	${DONE}
ifdef MOVETO
		mv ${BINNAME} ${MOVETO}
endif
endif
ifdef LIBNAME
all : CompMsg ${OBJECTS}
	${DISN} ${MSG}${MSG_MLIB}
	${ARC} ${LIBNAME} ${OBJECTS}
	${DONE}
ifdef MOVETO
		mv ${LIBNAME} ${MOVETO}
endif
endif

SUFFIXES : .o .c

.c.o : ${STDHEADERS}
ifeq (${VERBOSE},NO)
	${DISN} ${MSG}
	${SRCINFO} "^$< " MANIFEST
endif 
	${COMPILE} $<

# Other targets
#

clean : CleanMsg rmbinlib rmobj rmcore
	${DONE}

ifdef INSTALLDIR
install : InstallMsg doinst
	${DONE}
else
install ::
	${DIS} Sorry, nothing to install with this project.
endif

strip : StripMsg rmobj
	${DONE}

rmcore :
	-rm *.core 2> /dev/null

rmbinlib :
	-rm ${MOVETO}${BINNAME} ${MOVETO}${LIBNAME} 2> /dev/null

rmobj :
	-rm ${OBJECTS} 2> /dev/null
	-rm *.core 2> /dev/null

doinst :
	cp ${BINNAME} ${INSTALLDIR}
	chown root.bin ${INSTALLDIR}${BINNAME}
	chmod a+rx ${INSTALLDIR}${BINNAME}

# Messages
#
InstallMsg :
	${DISN} ${LEAD}${TITLE} - ${MSG_INSTALL}

CompMsg :
	${DIS} ${LEAD}${TITLE} - ${MSG_COMP}

CleanMsg :
	${DISN} ${LEAD}${TITLE} - ${MSG_CLEAN}

StripMsg :
	${DISN} ${LEAD}${TITLE} - ${MSG_STRIP}

ifeq (${VERBOSE},NO)                                                            
.SILENT ::
endif
