# Linkers/Compilers/Builders defined for the platforms
#

ifeq (${OS},UNIX)
	CC=			gcc
	MAKE=			gmake
	SHOWOFFCC_OPTS=		-Wall
	OPTCC_OPTS=		-O
	BASECC_OPTS=		-c -DUNIX
	BASELINK_OPTS=		${LIBRARYPATH}
	MAKE_OPTS=		
	ARCHIVER=		ar
	ARCHIVEROPTS=		rcs

	ifeq (${OSSUB},FREEBSD)
		BASECC_OPTS+=		-DFREEBSD -ggdb
		BASELINK_OPTS+=		-ggdb
		SHOWOFFCC_OPTS+=	-Wshadow -Wpointer-arith -Wcast-qual -Waggregate-return
		SRCINFO=		@-grep -e
		DISN=			@echo -n
		ifeq (${CURSES},YES)
			LIBRARIES+=	-lncurses
		endif
	endif
	ifeq (${OSSUB},LINUX)
		BASECC_OPTS+=		-DLINUX
		BASELINK_OPTS+=		
		SRCINFO=		@-grep -e
		DISN=			@echo -n
		ifeq (${CURSES},YES)
			LIBRARIES+=	-lncurses
		endif
        endif
	ifeq (${OSSUB},SOLARIS)
		BASECC_OPTS+=		-DSOLARIS
		BASELINK_OPTS+=		
		SRCINFO=		@-grep
		DISN=			@/usr/ucb/echo -n
		ifeq (${CURSES},YES)
			LIBRARIES+=	-lcurses
		endif
	endif

	COMPILE=		${CC} ${SHOWOFFCC_OPTS} ${OPTCC_OPTS} ${CC_OPTS} ${BASECC_OPTS}
	LINK=			${CC} ${BASELINK_OPTS} ${LINK_OPTS} -o
	ARC=			${ARCHIVER} ${ARCHIVEROPTS}
else
	COMPILE=		"NO COMPILER"
	LINK=			"NO LINKER"
	ARC=			"NO ARCHIVER"
endif
